/*
	 Evocation
	 Level: Clr 2, Evil 2
	 Components: V, S
	 Casting Time: 1 action
	 Range: Close
	 Area: 20-ft. radius emanation
	 Duration: 2 hours/level
	 Saving Throw: None
	 Spell Resistance: No

	 This spell imbues an area with negative energy.
	 All Charisma checks made to turn undead within
	 this area suffer a -3 profane penalty.  Undead entering
	 this area gain a +1 sacred bonus on attack rolls, damage rolls,
	 and saves. */

// i_temp_ci
/*
   Template for Casting Spell on item script.
   This script runs when a spell is cast on an item.

   How to use this script:
   Replace the word "temp" (in line 1) with the tag of the item.  Rename the script with this name.

   Additional Info:
   In general, all the item "tag-based" scripts will be named as follows:
   - a prefix ("i_" by defualt)
   - the tag of the item
   - a postfix indicating the item event.

   This script will be called automatically (by defualt) whether it exists or not.  If if does not exist, nothing happens.

   Note: this script runs on the character who cast the spell on the item.
   -ChazM
*/
// Name_Date

#include "nwn2_inc_spells"


#include "X0_I0_SPELLS"
#include "x2_inc_spellhook"

void main()
{

	/*
	  Spellcast Hook Code
	  Added 2003-06-23 by GeorgZ
	  If you want to make changes to all spells,
	  check x2_inc_spellhook.nss to find out more

	*/

	if (!X2PreSpellCastCode())
	{
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
		return;
	}// End of Spell Cast Hook

	effect eAOE = EffectAreaOfEffect(78,"rh_desecratea","","rh_desecrateb");
	object oTarget = GetSpellTargetObject();

	if (GetIsObjectValid(oTarget))
		SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF,9302));

	location lTarget = GetSpellTargetLocation();
	int nDuration = GetTotalLevels(OBJECT_SELF,FALSE)*2;

	int nMetaMagic = GetMetaMagicFeat();
	//Make sure duration does no equal 0
	if (nDuration < 2)
	{
		nDuration = 2;
	}
	//Check Extend metamagic feat.
	if (nMetaMagic == METAMAGIC_EXTEND)
	{
	nDuration = nDuration *2;	//Duration is +100%
	}

	//Create an instance of the AOE Object using the Apply Effect function
	ApplyEffectAtLocation(DURATION_TYPE_INSTANT,EffectNWN2SpecialEffectFile("sp_sonic_aoe_2"), lTarget);
	ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eAOE, lTarget, HoursToSeconds(nDuration));
}