#include "x0_i0_spells"

#include "x2_inc_spellhook"

void main()
{

	int nMetaMagic = GetMetaMagicFeat();

	effect eHit   = EffectVisualEffect(VFX_HIT_SPELL_EVIL);
	effect eDead1 = EffectAttackIncrease(1,ATTACK_BONUS_MISC);
	effect eDead2 = EffectDamageIncrease(1,DAMAGE_TYPE_NEGATIVE);
	effect eDead3 = EffectSavingThrowIncrease(SAVING_THROW_ALL,1,SAVING_THROW_TYPE_ALL);
	effect eDead4 = EffectTurnResistanceIncrease(2);

	effect eLink1 = EffectLinkEffects(eDead2,eDead1);
	effect eLink2 = EffectLinkEffects(eDead4,eDead3);

	int nDuration = GetCasterLevel(OBJECT_SELF)*2;
	//Enter Metamagic conditions
	if (nMetaMagic == METAMAGIC_EXTEND)
	{
		nDuration = nDuration *2; //Duration is +100%
	}
	object oTarget = GetEnteringObject();

	if(GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, GetAreaOfEffectCreator()))
		{
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
		}
		else
		{
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));
		}

		if(GetRacialType(oTarget) == RACIAL_SUBTYPE_UNDEAD || GetSubRace(oTarget) == RACIAL_SUBTYPE_UNDEAD)
		{
			ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink1, oTarget, HoursToSeconds(20));
			ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink2, oTarget, HoursToSeconds(20));
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eHit, oTarget);
		}
		else
		{
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eHit, oTarget);
		}
	}

}