/*
This ability deals 1d8 points of damage per two caster levels (max 5d8) to evil creatures
and staggersblinds them for 1 rounds.

A successful will save reduces the damage by half and negates the stagger (daze) effect.

The ability only deals half damage against creatures who are not evil or good,
and does not stagger them.

A successful Will save reduces the damage to one quarter.
*/

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook"

void main()
{
	if (!X2PreSpellCastCode())
	{
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
		return;
	}// End of Spell Cast Hook

	int nCasterLvl  = GetCasterLevel(OBJECT_SELF);
	int nMetaMagic  = GetMetaMagicFeat();
	int nCha        = GetAbilityModifier(ABILITY_CHARISMA, OBJECT_SELF);
	int nLevel      = GetTotalLevels(OBJECT_SELF, FALSE);
	if(nLevel > 10) nLevel = 10;

	int nDamage = d8(nLevel/2);
	effect eDamage;
	effect eDamage1;
	effect eDamage2 = EffectNWN2SpecialEffectFile("sp_holy_hit");
	effect eCurse1  = EffectCurse(4,0,0,0,0,0);
	effect eCurse2  = EffectVisualEffect(VFX_DUR_BLIND);
	effect eBlind   = EffectBlindness();
	int nDur = 1;
	int nAlignment;

	location lTarget = GetSpellTargetLocation();
	object oTarget = GetFirstObjectInShape(SHAPE_SPHERE,6.0,lTarget,FALSE,OBJECT_TYPE_CREATURE);

	effect eVis = EffectNWN2SpecialEffectFile("sp_holy_aoe");

	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVis, lTarget);

	while(GetIsObjectValid(oTarget))
	{
		nAlignment = GetAlignmentGoodEvil(oTarget);

		if(nAlignment == ALIGNMENT_GOOD)
		{
			nDamage = 0;
		}
		else if(nAlignment == ALIGNMENT_EVIL) //nothing
		{
			if(GetRacialType(oTarget) == RACIAL_TYPE_OUTSIDER) nDamage = d6(nLevel);

			if(WillSave(oTarget, 10 + nLevel + nCha, SAVING_THROW_TYPE_GOOD) == (SAVING_THROW_CHECK_SUCCEEDED || SAVING_THROW_CHECK_IMMUNE))
			{
				nDamage	= nDamage/2;
			}
			else
			{
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY,eBlind,oTarget,RoundsToSeconds(nDur));
			}
		}
		else //Neutral
		{
			if(WillSave(oTarget, 10 + nLevel + nCha, SAVING_THROW_TYPE_GOOD) == (SAVING_THROW_CHECK_SUCCEEDED || SAVING_THROW_CHECK_IMMUNE))
			{
				nDamage	= nDamage/4;
			}
			else
				nDamage = nDamage/2;
		}

		if(nDamage > 0)
		{
			eDamage1 = EffectDamage(nDamage, DAMAGE_TYPE_DIVINE);
			eDamage  = EffectLinkEffects(eDamage2, eDamage1);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
		}

		oTarget = GetNextObjectInShape(SHAPE_SPHERE,6.0,lTarget,FALSE,OBJECT_TYPE_CREATURE);
	}


}